Index: DirectShowFilters/TsWriter/source/SkyChannelDecoder.cpp
===================================================================
--- DirectShowFilters/TsWriter/source/SkyChannelDecoder.cpp	(revision 0)
+++ DirectShowFilters/TsWriter/source/SkyChannelDecoder.cpp	(revision 0)
@@ -0,0 +1,155 @@
+/* 
+ *	Copyright (C) 2006-2008 Team MediaPortal
+ *	http://www.team-mediaportal.com
+ *
+ *  This Program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2, or (at your option)
+ *  any later version.
+ *   
+ *  This Program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ *  GNU General Public License for more details.
+ *   
+ *  You should have received a copy of the GNU General Public License
+ *  along with GNU Make; see the file COPYING.  If not, write to
+ *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
+ *  http://www.gnu.org/copyleft/gpl.html
+ *
+ */
+
+#include "SkyChannelDecoder.h"
+#include "SkyChannelParser.h"
+#include "SkyManager.h"
+
+
+typedef struct SkyBouquet;
+
+
+//	Cstr
+CSkyChannelDecoder::CSkyChannelDecoder(CSkyChannelParser* parentSkyChannelParser)
+{
+	skyChannelParser = parentSkyChannelParser;
+
+}
+
+//	Flzr
+CSkyChannelDecoder::~CSkyChannelDecoder()
+{
+}
+
+//	Fired when a new channel network data section is received
+void CSkyChannelDecoder::OnNetworkDataSectionReceived(unsigned short pid, CSection* dataSection)
+{
+	CSkyManager* skyManager = skyChannelParser->GetSkyManager();
+
+	Mediaportal::CEnterCriticalSection enter(skyManager->criticalSection);
+
+	//	If all bouquets are already fully populated, return
+	if(skyManager->AreAllBouquetsPopulated())
+		return;
+
+	//	Check this table carries channel data
+	if(!skyManager->DoesTidCarryChannelNetworkData(dataSection->table_id))
+		return;
+
+	byte* buffer = dataSection->Data;
+	
+	int bouquetId = (buffer[3] << 8) + buffer[4];
+	int bouquetDescriptorLength = ((buffer[8] & 0x0F ) << 8) + buffer[9];
+
+	SkyBouquet* skyBouquet = skyManager->GetBouquet(bouquetId);
+
+	if(skyBouquet == NULL)
+	{
+		skyManager->LogError("CSkyChannelDecoder::OnNetworkDataSectionReceived() - Error, failed to create new or retrieve existing Sky bouquet");
+		return;
+	}
+
+	//	If the bouquet is not initialized, this is the first time we have seen it
+	if(!skyBouquet->isInitialized)
+	{
+		//	Populate first section number seen
+		skyBouquet->firstReceivedSectionNumber = dataSection->section_number;
+		skyBouquet->isInitialized = true;
+	}
+
+	else
+	{
+		//	If all the channels are already populated for this bouquet, we can skip this packet
+		if(skyBouquet->isPopulated)
+			return;
+		
+		//	If we are back round to the first section we saw for this bouquet, it is now fully populated
+		if(dataSection->section_number == skyBouquet->firstReceivedSectionNumber)
+		{
+			skyBouquet->isPopulated = true;
+			skyManager->NotifyBouquetPopulated();
+
+			return;
+		}
+	}
+
+	int body = 10 + bouquetDescriptorLength;
+    int bouquetPayloadLength = ((buffer[body + 0] & 0x0F) << 8) + buffer[body + 1];
+	int endOfPacket = body + bouquetPayloadLength + 2;
+	int currentTransportGroup = body + 2;
+
+	//	Loop through all transport groups in this packet
+	while(currentTransportGroup < endOfPacket)
+	{
+		//	Extract transport id and network id
+		unsigned short int transportId = (buffer[currentTransportGroup + 0] << 8) + buffer[currentTransportGroup + 1];
+		unsigned short int networkId = (buffer[currentTransportGroup + 2] << 8) + buffer[currentTransportGroup + 3];
+
+		int transportGroupLength = ((buffer[currentTransportGroup + 4] & 0x0F) << 8) + buffer[currentTransportGroup + 5];
+		int currentTransportDescriptor = currentTransportGroup + 6;
+		int endOfTransportGroupDescriptors = currentTransportDescriptor + transportGroupLength;
+
+		while(currentTransportDescriptor < endOfTransportGroupDescriptors)
+		{
+			//	Descriptor type
+			byte descriptorType = buffer[currentTransportDescriptor];
+
+			int descriptorLength = buffer[currentTransportDescriptor + 1];
+			int currentServiceDescriptor = currentTransportDescriptor + 2;
+			int endOfServiceDescriptors = currentServiceDescriptor + descriptorLength - 2;
+
+			//	If the descriptor is channel information (0xB1)
+			if(descriptorType == 0xB1)
+			{
+				while(currentServiceDescriptor < endOfServiceDescriptors)
+				{
+					//	Extract service id and channel information
+					int serviceId = (buffer[currentServiceDescriptor + 2] << 8) + buffer[currentServiceDescriptor + 3];
+					int channelId = (buffer[currentServiceDescriptor + 5] << 8) + buffer[currentServiceDescriptor + 6];
+					int skyChannelNumber = (buffer[currentServiceDescriptor + 7] << 8) + buffer[currentServiceDescriptor + 8];
+					
+					SkyChannel* skyChannel = skyManager->GetChannel(channelId);
+
+					//	If the channel information has not been populated, do this now
+					if(!skyChannel->isPopulated)
+					{
+						skyChannel->networkId = networkId;
+						skyChannel->transportId = transportId;
+						skyChannel->serviceId = serviceId;
+						skyChannel->epgChannelNumber = skyChannelNumber;
+						skyChannel->isPopulated = true;
+					}
+				
+					currentServiceDescriptor += 9;
+				}
+			}
+
+			currentTransportDescriptor += descriptorLength + 2;
+		}
+
+		//	Move to the next transport stream
+		currentTransportGroup += transportGroupLength + 6;
+	}
+
+	
+
+	
+}
Index: DirectShowFilters/TsWriter/source/SkyChannelDecoder.h
===================================================================
--- DirectShowFilters/TsWriter/source/SkyChannelDecoder.h	(revision 0)
+++ DirectShowFilters/TsWriter/source/SkyChannelDecoder.h	(revision 0)
@@ -0,0 +1,47 @@
+/* 
+ *	Copyright (C) 2006-2008 Team MediaPortal
+ *	http://www.team-mediaportal.com
+ *
+ *  This Program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2, or (at your option)
+ *  any later version.
+ *   
+ *  This Program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ *  GNU General Public License for more details.
+ *   
+ *  You should have received a copy of the GNU General Public License
+ *  along with GNU Make; see the file COPYING.  If not, write to
+ *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
+ *  http://www.gnu.org/copyleft/gpl.html
+ *
+ */
+
+#pragma once
+#include <windows.h>
+#include "..\..\shared\SectionDecoder.h"
+#include "CriticalSection.h"
+#include "EnterCriticalSection.h"
+
+
+class CSkyChannelParser;
+
+class CSkyChannelDecoder
+{
+public:
+
+	//	Cstr
+	CSkyChannelDecoder(CSkyChannelParser* parentSkyChannelParser);
+	~CSkyChannelDecoder();
+
+	//	Fired when a new channel network data section is received
+	void OnNetworkDataSectionReceived(unsigned short pid, CSection* dataSection);
+
+private:
+
+	CSkyChannelParser* skyChannelParser;
+
+
+};
Index: DirectShowFilters/TsWriter/source/SkyChannelParser.cpp
===================================================================
--- DirectShowFilters/TsWriter/source/SkyChannelParser.cpp	(revision 0)
+++ DirectShowFilters/TsWriter/source/SkyChannelParser.cpp	(revision 0)
@@ -0,0 +1,81 @@
+/* 
+ *	Copyright (C) 2006-2008 Team MediaPortal
+ *	http://www.team-mediaportal.com
+ *
+ *  This Program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2, or (at your option)
+ *  any later version.
+ *   
+ *  This Program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ *  GNU General Public License for more details.
+ *   
+ *  You should have received a copy of the GNU General Public License
+ *  along with GNU Make; see the file COPYING.  If not, write to
+ *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
+ *  http://www.gnu.org/copyleft/gpl.html
+ *
+ */
+
+
+#include "SkyChannelParser.h"
+#include "SkyManager.h"
+
+//	Cstr
+CSkyChannelParser::CSkyChannelParser(CSkyManager *parentSkyManager)
+{
+	skyManager = parentSkyManager;
+
+	//	Initialize child objects
+	skyChannelDecoder = new CSkyChannelDecoder(this);
+
+	//	Initialize the section decoders
+	channelNetworkDataSectionDecoder = new CSectionDecoder();
+
+	channelNetworkDataSectionDecoder->SetCallBack(this);
+	channelNetworkDataSectionDecoder->SetPid(PID_SKYUKIT_EPG_CHANNEL_INFORMATION);
+}
+
+//	Flzr
+CSkyChannelParser::~CSkyChannelParser()
+{
+}
+
+//	Gets the parent sky manager reference
+CSkyManager* CSkyChannelParser::GetSkyManager()
+{
+	return skyManager;
+}
+
+//	Fired when a ts packet is received
+void CSkyChannelParser::OnTsPacket(CTsHeader& header, byte* tsPacket)
+{
+	Mediaportal::CEnterCriticalSection enter(skyManager->criticalSection);
+
+	unsigned short pid = header.Pid;
+
+	//	If we are grabbing epg
+	if(skyManager->IsEpgGrabbingActive())
+	{
+		//	If channel network data
+		if(skyManager->DoesPidCarryChannelNetworkData(pid))
+			channelNetworkDataSectionDecoder->OnTsPacket(header, tsPacket);
+	}
+}
+
+//	Fired when a new section is received
+void CSkyChannelParser::OnNewSection(int pid, int tableId, CSection& section)
+{
+	Mediaportal::CEnterCriticalSection enter(skyManager->criticalSection);
+
+	//	If we are grabbing epg
+	if(skyManager->IsEpgGrabbingActive())
+	{
+		//	If channel network data
+		if(skyManager->DoesPidCarryChannelNetworkData(pid))
+			skyChannelDecoder->OnNetworkDataSectionReceived(pid, &section);
+	}
+}
+
Index: DirectShowFilters/TsWriter/source/SkyChannelParser.h
===================================================================
--- DirectShowFilters/TsWriter/source/SkyChannelParser.h	(revision 0)
+++ DirectShowFilters/TsWriter/source/SkyChannelParser.h	(revision 0)
@@ -0,0 +1,62 @@
+/* 
+ *	Copyright (C) 2006-2008 Team MediaPortal
+ *	http://www.team-mediaportal.com
+ *
+ *  This Program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2, or (at your option)
+ *  any later version.
+ *   
+ *  This Program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ *  GNU General Public License for more details.
+ *   
+ *  You should have received a copy of the GNU General Public License
+ *  along with GNU Make; see the file COPYING.  If not, write to
+ *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
+ *  http://www.gnu.org/copyleft/gpl.html
+ *
+ */
+
+#pragma once
+#include <vector>
+#include <windows.h>
+#include "SkyChannelDecoder.h"
+#include "..\..\shared\SectionDecoder.h"
+#include "..\..\shared\iSectionCallback.h"
+#include "CriticalSection.h"
+#include "EnterCriticalSection.h"
+
+using namespace std;
+
+class CSkyManager;
+
+
+class CSkyChannelParser
+	: public ISectionCallback
+{
+public:
+
+	CSkyChannelParser(CSkyManager* parentSkyManager);
+	~CSkyChannelParser();
+
+	//	Gets the parent sky manager reference
+	CSkyManager* GetSkyManager();
+
+	//	Fired when a new ts packed is received
+	void OnTsPacket(CTsHeader& header, byte* tsPacket);
+
+	//	Fired when a new section is received
+	void OnNewSection(int pid, int tableId, CSection& section);
+
+private:
+
+	CSkyManager* skyManager;
+
+	//	Child objects
+	CSkyChannelDecoder* skyChannelDecoder;
+
+	CSectionDecoder* channelNetworkDataSectionDecoder;
+
+};
Index: DirectShowFilters/TsWriter/source/SkyEpgParser.cpp
===================================================================
--- DirectShowFilters/TsWriter/source/SkyEpgParser.cpp	(revision 0)
+++ DirectShowFilters/TsWriter/source/SkyEpgParser.cpp	(revision 0)
@@ -0,0 +1,139 @@
+/* 
+ *	Copyright (C) 2006-2008 Team MediaPortal
+ *	http://www.team-mediaportal.com
+ *
+ *  This Program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2, or (at your option)
+ *  any later version.
+ *   
+ *  This Program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ *  GNU General Public License for more details.
+ *   
+ *  You should have received a copy of the GNU General Public License
+ *  along with GNU Make; see the file COPYING.  If not, write to
+ *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
+ *  http://www.gnu.org/copyleft/gpl.html
+ *
+ */
+
+#include "SkyEpgParser.h"
+#include "SkyManager.h"
+
+
+//	Cstr
+CSkyEpgParser::CSkyEpgParser(CSkyManager* parentSkyManager)
+{
+	Mediaportal::CEnterCriticalSection enter(parentSkyManager->criticalSection);
+
+	try
+	{
+		skyManager = parentSkyManager;
+
+		//	Create child objects
+		skyEpgTitleDecoder = new CSkyEpgTitleDecoder(this);
+		skyEpgSummaryDecoder = new CSkyEpgSummaryDecoder(this);
+
+		//	Initialize all title section decoders
+		for(unsigned short i = PID_SKYUKIT_EPG_TITLES_F; i <= PID_SKYUKIT_EPG_TITLES_T; i++)
+		{
+			CSectionDecoder* newTitleDecoder = new CSectionDecoder();
+
+			newTitleDecoder->SetCallBack(this);
+			newTitleDecoder->SetPid(i);
+			newTitleDecoder->EnableCrcCheck(true);
+
+			epgSectionDecoders.insert(pair<unsigned short, CSectionDecoder*>(i, newTitleDecoder));
+		}
+		
+		//	Initialize all normal summary section decoders
+		for(unsigned short i = PID_SKYUKIT_EPG_SUMMARIES_F; i <= PID_SKYUKIT_EPG_SUMMARIES_T; i++)
+		{
+			CSectionDecoder* newSummaryDecoder = new CSectionDecoder();
+
+			newSummaryDecoder->SetCallBack(this);
+			newSummaryDecoder->SetPid(i);
+			newSummaryDecoder->EnableCrcCheck(true);
+
+			epgSectionDecoders.insert(pair<unsigned short, CSectionDecoder*>(i, newSummaryDecoder));
+		}
+		
+
+	}
+	catch(...)
+	{
+		LogDebug("CSkyEpgParser::CSkyEpgParser() - Exception in constructor");
+	}
+}
+
+//	Flzr
+CSkyEpgParser::~CSkyEpgParser()
+{
+}
+
+//	Gets the parent sky manager reference
+CSkyManager* CSkyEpgParser::GetSkyManager()
+{
+	return skyManager;
+}
+
+//	Fired when a new ts packet is received
+void CSkyEpgParser::OnTsPacket(CTsHeader& header, byte* tsPacket)
+{
+	Mediaportal::CEnterCriticalSection enter(skyManager->criticalSection);
+
+	//	If epg grabbing is not active, skip
+	if(!skyManager->IsEpgGrabbingActive())
+		return;
+
+	unsigned short pid = header.Pid;
+
+	//	If this pid carries epg data
+	if(skyManager->DoesPidCarryEpgData(pid))
+	{
+		//	Try and find the section decoder for this pid
+		map<unsigned short, CSectionDecoder*>::iterator epgSectionDecodersIterator = epgSectionDecoders.find(pid);
+		
+		//	If we couldnt find the decoder for this pid
+		if(epgSectionDecodersIterator == epgSectionDecoders.end())
+		{
+			skyManager->LogError("CSkyEpgParser::OnTsPacket() - Unexpected pid in ts packet");
+			return;
+		}
+
+		//	Else pass the packet to the section decoder
+		epgSectionDecodersIterator->second->OnTsPacket(header, tsPacket);
+	}
+}
+
+//	Fired when a new section is received
+void CSkyEpgParser::OnNewSection(int pid, int tableId, CSection& section)
+{
+	Mediaportal::CEnterCriticalSection enter(skyManager->criticalSection);
+
+	//	If epg grabbing is not active, skip
+	if(!skyManager->IsEpgGrabbingActive())
+		return;
+
+	//	If this is a title data section
+	if(skyManager->DoesPidCarryEpgTitleData(pid))
+	{
+		//	Pass to the title decoder
+		skyEpgTitleDecoder->OnTitleSectionReceived(pid, &section);
+	}
+
+	//	Else if summary data section
+	else if(skyManager->DoesPidCarryEpgSummaryData(pid))
+	{
+		//	Pass to the summary decoder
+		skyEpgSummaryDecoder->OnSummarySectionReceived(pid, &section);
+	}
+	
+	else
+	{
+		skyManager->LogError("CSkyEpgParser::OnNewSection() - Unexpected pid received in section");
+		return;
+	}
+}
Index: DirectShowFilters/TsWriter/source/SkyEpgParser.h
===================================================================
--- DirectShowFilters/TsWriter/source/SkyEpgParser.h	(revision 0)
+++ DirectShowFilters/TsWriter/source/SkyEpgParser.h	(revision 0)
@@ -0,0 +1,67 @@
+/* 
+ *	Copyright (C) 2006-2008 Team MediaPortal
+ *	http://www.team-mediaportal.com
+ *
+ *  This Program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2, or (at your option)
+ *  any later version.
+ *   
+ *  This Program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ *  GNU General Public License for more details.
+ *   
+ *  You should have received a copy of the GNU General Public License
+ *  along with GNU Make; see the file COPYING.  If not, write to
+ *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
+ *  http://www.gnu.org/copyleft/gpl.html
+ *
+ */
+
+#pragma once
+#include <vector>
+#include <map>
+#include <windows.h>
+#include "SkyEpgTitleDecoder.h"
+#include "SkyEpgSummaryDecoder.h"
+#include "..\..\shared\SectionDecoder.h"
+#include "..\..\shared\iSectionCallback.h"
+#include "CriticalSection.h"
+#include "EnterCriticalSection.h"
+
+using namespace std;
+
+
+class CSkyManager;
+
+
+class CSkyEpgParser
+	: public ISectionCallback
+{
+public:
+
+	//	Cstr/Dstr
+	CSkyEpgParser(CSkyManager* parentSkyManager);
+	~CSkyEpgParser();
+
+	//	Gets the parent sky manager reference
+	CSkyManager* GetSkyManager();
+
+	//	Fired when a new ts packed is received
+	void OnTsPacket(CTsHeader& header, byte* tsPacket);
+
+	//	Fired when a new section is received
+	void OnNewSection(int pid, int tableId, CSection& section);
+
+
+private:
+
+	//	Parent Sky manager
+	CSkyManager* skyManager;
+
+	CSkyEpgTitleDecoder* skyEpgTitleDecoder;
+	CSkyEpgSummaryDecoder* skyEpgSummaryDecoder;
+
+	map<unsigned short, CSectionDecoder*> epgSectionDecoders;
+};
Index: DirectShowFilters/TsWriter/source/SkyEpgSummaryDecoder.cpp
===================================================================
--- DirectShowFilters/TsWriter/source/SkyEpgSummaryDecoder.cpp	(revision 0)
+++ DirectShowFilters/TsWriter/source/SkyEpgSummaryDecoder.cpp	(revision 0)
@@ -0,0 +1,215 @@
+/* 
+ *	Copyright (C) 2006-2008 Team MediaPortal
+ *	http://www.team-mediaportal.com
+ *
+ *  This Program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2, or (at your option)
+ *  any later version.
+ *   
+ *  This Program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ *  GNU General Public License for more details.
+ *   
+ *  You should have received a copy of the GNU General Public License
+ *  along with GNU Make; see the file COPYING.  If not, write to
+ *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
+ *  http://www.gnu.org/copyleft/gpl.html
+ *
+ */
+
+
+#include "SkyEpgSummaryDecoder.h"
+#include "SkyEpgParser.h"
+#include "SkyManager.h"
+
+
+//	Cstr
+CSkyEpgSummaryDecoder::CSkyEpgSummaryDecoder(CSkyEpgParser *parentSkyEpgParser)
+{
+	skyEpgParser = parentSkyEpgParser;
+}
+
+//	Flzr
+CSkyEpgSummaryDecoder::~CSkyEpgSummaryDecoder()
+{
+}
+
+//	Fired when a summary section is received
+void CSkyEpgSummaryDecoder::OnSummarySectionReceived(unsigned short pid, CSection *section)
+{
+	CSkyManager* skyManager = skyEpgParser->GetSkyManager();
+	
+	Mediaportal::CEnterCriticalSection enter(skyManager->criticalSection);
+
+	//	If the summary data carousel is complete for this pid, we can discard the data as we already have it
+	if(skyManager->IsSummaryDataCarouselOnPidComplete(pid))
+		return;
+
+	//	Validate table id
+	if(!skyManager->DoesTidCarryEpgSummaryData(section->table_id))
+		return;
+
+	byte* buffer = section->Data;
+
+	//	Total length of summary data (2 less for this length field)
+	int totalLength = (((buffer[1] & 0x0F) << 8) + buffer[2]) - 2;
+	
+	//	If this section is a valid length (14 absolute minimum with 1 blank summary)
+	if(section->section_length < 14)
+		return;
+
+	//	Get the channel id that this section's summary data relates to
+	unsigned short channelId = (buffer[3] << 8) + buffer[4];
+	unsigned short mjdStartDate = (buffer[8] << 8) + buffer[9];
+	
+	//	Check channel id and start date are valid
+	if(channelId == 0 || mjdStartDate == 0)
+		return;
+
+	//	Always starts at 10th byte
+	int currentSummaryItem = 10;
+
+	int iterationCounter = 0;
+
+	//	Loop while we have more summary data
+	while(currentSummaryItem < totalLength)
+	{
+		if(iterationCounter > 512)
+		{
+			skyManager->LogError("CSkyEpgTitleDecoder::OnSummarySectionReceived() - Error, infinite loop detected.  Dropping packet.");
+			return;
+		}
+
+		iterationCounter++;
+
+		//	Extract event id, header type and body length
+		unsigned short eventId = (buffer[currentSummaryItem + 0] << 8) + buffer[currentSummaryItem + 1];
+		unsigned char headerType = (buffer[currentSummaryItem + 2] & 0xF0 ) >> 4;
+		unsigned short bodyLength = ((buffer[currentSummaryItem + 2] & 0x0F) << 8) + buffer[currentSummaryItem + 3];
+
+		//	Build the carousel lookup id
+		unsigned int carouselLookupId = (channelId << 16) + eventId;
+
+		//	Notify the parser that a title has been received
+		skyManager->OnSummaryReceived(pid, carouselLookupId);
+
+		//	If the summary carousel for this pid is now complete, we can return
+		if(skyManager->IsSummaryDataCarouselOnPidComplete(pid))
+			return;
+
+		//	Get the epg event we are to populate from the manager
+		SkyEpgEvent* epgEvent = skyManager->GetEpgEvent(channelId, eventId);
+
+		//	Check we have the event reference
+		if(epgEvent == NULL)
+		{
+			skyManager->LogError("CSkyEpgSummaryDecoder::OnSummarySectionReceived() - Error, failed to get event reference");
+			return;
+		}
+
+		int headerLength;
+
+		//	If this is an extended header (0xF) (7 bytes long)
+		if(headerType == 0xF)
+			headerLength = 7;
+
+		//	Else if normal header (0xB) (4 bytes long)
+		else if(headerType == 0xB)
+			headerLength = 4;
+
+		//	Else other unknown header (not worked them out yet, at least 4 more)
+		//	Think these are only used for box office and adult channels so not really important
+		else
+		{
+			//	Cannot parse the rest of this packet as we dont know the header lengths/format etc
+			return;
+		}
+
+		
+		//	If body length is less than 3, there is no summary data for this event, move to next
+		if(bodyLength < 3)
+		{
+			currentSummaryItem += (headerLength + bodyLength);
+			continue;
+		}
+
+
+		//	Move to the body of the summary
+		int currentSummaryItemBody = currentSummaryItem + headerLength;
+
+		//	Extract summary signature and huffman buffer length
+		unsigned short summaryDescriptor = buffer[currentSummaryItemBody + 0];
+		unsigned short encodedBufferLength = buffer[currentSummaryItemBody + 1];
+		
+		//	If normal summary item (0xB9)
+		if(summaryDescriptor == 0xB9)	
+		{
+			if(epgEvent->summary == NULL)
+			{
+				//	Decode the summary
+				epgEvent->summary = skyManager->DecodeHuffmanData(&buffer[currentSummaryItemBody + 2], encodedBufferLength);
+
+				//	If failed to decode
+				if(epgEvent->summary == NULL)
+				{
+					char* cannotDecodeBuffer = "(Cannot decode)";
+					int cannotDecodeBufferLength = strlen(cannotDecodeBuffer) + 1;
+					epgEvent->summary = (byte*) malloc(cannotDecodeBufferLength);
+
+					memcpy(epgEvent->summary, cannotDecodeBuffer, cannotDecodeBufferLength);
+				}
+
+				else
+					//	Notify the manager (for statistics)
+					skyManager->OnSummaryDecoded();
+			}
+		}
+
+		//	Else if (0xBB) - Unknown data item (special box office or adult?)
+		//	Seems very rare (1 in every 2000 or so), so not important really
+		else if(summaryDescriptor == 0xBB)
+		{
+			//	Skip
+		}
+
+		//	Else other unknown data item, there are a few others that are unknown
+		else
+		{
+			return;
+			//skyManager->LogError("CSkyEpgSummaryDecoder::OnSummarySectionReceived() - Error, unrecognised summary descriptor");
+		}
+
+		//	Is there any footer information?
+		int footerLength = bodyLength - encodedBufferLength - 2;
+
+		if(footerLength >= 4)
+		{
+			int footerPointer = currentSummaryItemBody + 2 + encodedBufferLength;
+
+			//	Get the descriptor
+			short footerDescriptor = buffer[footerPointer + 0];
+
+			//	If series id information (0xC1)
+			if(footerDescriptor == 0xC1)
+			{
+				epgEvent->seriesId = (buffer[footerPointer + 2] << 8) + (buffer[footerPointer + 3] << 0);
+			}			
+		}		
+
+		//	Move to next summary item
+		currentSummaryItem += (bodyLength + headerLength);
+	}
+
+	//	Check the packet was parsed correctly - seem to get a few of these.  
+	//	Seems to be some extra information tagged onto the end of some summary packets (1 in every 2000 or so)
+	//	Not worked this out - possibly box office information
+	if(currentSummaryItem != (totalLength + 1))
+	{
+		//skyManager->LogError("CSkyEpgSummaryDecoder::OnSummarySectionReceived() - Warning, summary packet was not parsed correctly - pointer not in expected place");
+		
+		return;
+	}
+
+}
Index: DirectShowFilters/TsWriter/source/SkyEpgSummaryDecoder.h
===================================================================
--- DirectShowFilters/TsWriter/source/SkyEpgSummaryDecoder.h	(revision 0)
+++ DirectShowFilters/TsWriter/source/SkyEpgSummaryDecoder.h	(revision 0)
@@ -0,0 +1,47 @@
+/* 
+ *	Copyright (C) 2006-2008 Team MediaPortal
+ *	http://www.team-mediaportal.com
+ *
+ *  This Program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2, or (at your option)
+ *  any later version.
+ *   
+ *  This Program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ *  GNU General Public License for more details.
+ *   
+ *  You should have received a copy of the GNU General Public License
+ *  along with GNU Make; see the file COPYING.  If not, write to
+ *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
+ *  http://www.gnu.org/copyleft/gpl.html
+ *
+ */
+
+#pragma once
+#include <windows.h>
+#include "..\..\shared\SectionDecoder.h"
+#include "CriticalSection.h"
+#include "EnterCriticalSection.h"
+
+class CSkyEpgParser;
+
+
+class CSkyEpgSummaryDecoder
+{
+public:
+
+	//	Cstr/Flzr
+	CSkyEpgSummaryDecoder(CSkyEpgParser* parentSkyEpgParser);
+	~CSkyEpgSummaryDecoder();
+
+	//	Fired when a summary section is received
+	void OnSummarySectionReceived(unsigned short pid, CSection* section);
+
+private:
+
+	CSkyEpgParser* skyEpgParser;
+
+
+};
